<template>
  <v-chip
    draggable
    :filter="variant !== 'assist'"
    variant="outlined"
    :text="text"
    :pill="avatar"
    :elevation="elevation"
    :rounded="variant === 'input' ? avatar ? 'pill' : 'lg' : 'lg'"
    :filter-icon="filterIcon"
    :disabled="disabled"
    :prepend-icon="prependIcon"
    :append-icon="appendIcon"
    :closable="closable"
    close-icon="mdi-close"
    @click:close="onClose"
  >
    <template v-if="avatar" #prepend>
      <slot name="prepend">
        <div class="ml-1.5">
          <svn-pro-avatar
            :type="avatarType"
            :image="avatarImage"
            :firstname="text"
            :size="24"
            start
          />
        </div>
      </slot>
    </template>

    <template v-if="isSlotAppend" #append>
      <slot name="append"/>
    </template>
  </v-chip>
</template>

<script setup>
import SvnProAvatar from '../avatar/SvnProAvatar.vue';

const props = defineProps({
  variant: {
    type: String,
    default: 'input',
  },
  text: {
    type: String,
    default: 'Label',
  },
  prependIcon: {
    type: String,
    default: undefined,
  },
  appendIcon: {
    type: String,
    default: undefined,
  },
  closable: {
    type: Boolean,
    default: false,
  },
  avatar: {
    type: Boolean,
    default: false,
  },
  filterIcon: {
    type: String,
    default: undefined,
  },
  avatarType: {
    type: String,
    default: 'monogram',
  },
  avatarImage: {
    type: String,
    default: undefined,
  },
  disabled: {
    type: Boolean,
    default: false,
  },
  elevation: {
    type: Number,
    default: undefined,
  },
  isSlotAppend: {
    type: Boolean,
    default: false,
  },
});

const emit = defineEmits([
  'on-close'
])

const onClose = () => {
  emit('on-close')
}
</script>